chiark / gitweb /
el/dot-emacs.el: Fix bungled `LD_PRELOAD' hack removal in Eshell.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   profile shell-rc shell-logout
135   bash-profile:.bash_profile
136   bash-completion:.bash_completion bashrc inputrc
137   shrc
138   zprofile zshrc
139   emacs emacs-calc vm gnus.el ercrc.el
140   vimrc mg zile lesskey sqliterc
141   parallel-config:.parallel/config
142   ipython-config.py:.ipython/profile_default/ipython_config.py
143   ipython-key-bindings.py:.ipython/profile_default/startup/50-key-bindings.py
144   ditz-config
145   mailrc signature muttrc
146   cgrc tigrc
147   gdbinit
148   guile
149   rcrc
150   toprc
151   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
152   pulse-daemon.conf:.pulse/daemon.conf
153   aspell.conf
154   tclshrc:.tclshrc tclshrc:.wishrc
155   lisp-init.lisp:.cmucl-init.lisp
156     lisp-init.lisp:.sbclrc
157     lisp-init.lisp:.clisprc.lisp
158     lisp-init.lisp:.eclrc
159   swank.lisp
160   mdw-build.conf:.config/mdw-build.conf
161   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
162   dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
163 [ "$xstuff" ] && dotfiles="$dotfiles
164   xinitrc xsession xmodmap vncrc vncsession
165   fonts.conf
166   stalonetrayrc
167   putty-defaults:.putty/sessions/Default%20Settings
168   mdw.session:.config/gnome-session/sessions/mdw.session
169   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
170   e-keybindings.cfg:.enlightenment/keybindings.cfg
171   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
172   e16-bindings:.e16/bindings.cfg
173   gtkrc-2.0
174   gtk3.css:.config/gtk-3.0/gtk.css
175   gtk3-settings.ini:.config/gtk-3.0/settings.ini"
176 echo "Installing dotfiles..."
177 for d in $dotfiles; do
178   target=.$d
179   case $d in
180     *:*) target=${d#*:} d=${d%%:*};;
181   esac
182   ft=$HOME$sub/$target
183   dir=${ft%/*}
184   mkdir -p $dir
185   ln -s $here/dot/$d $ft.new
186   mv $ft.new $ft
187   echo "  $target"
188 done
189 echo "  all done."
190
191 ## CPP-hack files which need it.
192 cppfiles=""
193 [ "$xstuff" ] && cppfiles="$cppfiles
194   Xdefaults"
195 echo "Hacking files with C preprocessor..."
196 defs="-DHOME=$HOME -DPROFILE=$here"
197 defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
198 for c in $cppfiles; do
199   target=.$c
200   case $c in
201     *:*) target=${c#*:} c=${c%%:*};;
202   esac
203   ft=$HOME$sub/$target
204   dir=${ft%/*}
205   mkdir -p $dir
206   cpp -P $defs dot/$c -o $ft.new
207   mv $ft.new $ft
208   echo "  $target"
209 done
210 echo "  all done."
211
212 ## Substitute things which need substituting.
213 dotfilessubst="
214   gitconfig
215   mykermrc
216   pulse-default.pa.in:.pulse/default.pa"
217 echo "Installing dotfiles with substitutions..."
218 for d in $dotfilessubst; do
219   case $d in
220     *:*) target=${d#*:} d=${d%%:*};;
221     *) target=.$d d=$d.in;;
222   esac
223   ft=$HOME$sub/$target
224   dir=${ft%/*}
225   mkdir -p $dir
226   sed "
227 1i\\
228 ### generated by $here/setup; do not edit!\\
229
230 /@home@/ s\a\a$HOME\ag
231 /@profile@/ s\a\a$here\ag
232 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
233 " dot/$d >$ft.new
234   mv $ft.new $ft
235   echo "  $target"
236 done
237 echo "  all done."
238
239 ## Symlink backgrounds.
240 backgrounds=$(cd bg && echo *)
241 if [ "$xstuff" ]; then
242   echo "Installing backgrounds..."
243   for b in $backgrounds; do
244     for e in enlightenment e16; do
245       dir=$HOME$sub/.$e/backgrounds
246       t=$dir/$b
247       mkdir -p $dir
248       ln -s $here/bg/$b $t.new
249       mv $t.new $t
250     done
251     echo "  $b"
252   done
253   echo "        all done."
254 fi
255
256 ###--------------------------------------------------------------------------
257 ### Install useful scripts included in this package.
258
259 scripts="
260   mdw-editor
261   mdw-pager
262   mdw-conf
263   mdw-build mdw-sbuild mdw-sbuild-server
264   update-buildable-branch
265   emacsclient-hack
266   movemail-hack
267   sendmail-hack
268   aspell-hack
269   emerge-hack
270   lesspipe.sh
271   run-with-shell-env
272   start-ssh-agent
273   start-ssh-pageant
274   add-ssh-keys
275   svnwrap
276   guest-console
277   hyperspec"
278 [ "$xstuff" ] && scripts="$scripts
279   xinitcmd
280   un-backslashify-selection
281   lock-screen
282   xpra-start-xdummy
283   xshutdown"
284 echo "Installing scripts..."
285 mkdir -p $HOME$sub/bin
286 for s in $scripts; do
287   ft=$HOME$sub/bin/$s
288   ln -s $here/bin/$s $ft.new
289   mv $ft.new $ft
290   echo "  $s"
291 done
292 echo "  all done."
293
294 hacks="
295   ssh:ssh"
296 echo "Installing hacks..."
297 for h in $hacks; do
298   d=${h%%:*} h=${h#*:}
299   ft=$HOME$sub/bin/hacks/$d
300   mkdir -p $ft
301   ln -s $here/hacks/$h $ft/$h.new
302   mv $ft/$h.new $ft/$h
303   echo "  $d:$h"
304 done
305 echo "  all done."
306
307 ###--------------------------------------------------------------------------
308 ### Set up the Emacs config.
309
310 $echon "Finding a suitable emacs:$echoc"
311 emacs=no
312 for i in emacs24 emacs23 emacs22 emacs21 emacs; do
313   if type -p >/dev/null $i; then
314     emacs=$i
315     break
316   fi
317 done
318 if [ $emacs = no ]; then
319   echo " failed."
320   emacs=:
321 else
322   echo " $emacs."
323 fi
324
325 echo "Installing Emacs packages..."
326 emacspkg="
327   make-regexp
328   ew-hols
329   mdw-gnus-patch
330   git git-blame vc-git stgit
331   mdw-multiple-cursors
332   quilt"
333 for elib in $emacspkg; do
334   $echon "  $elib:$echoc"
335   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
336        (progn
337          (setq load-path (nconc load-path (list "~/lib/emacs")))
338          (kill-emacs (condition-case nil
339                          (progn (load-library "'"$elib"'") 0)
340                        (error 1))))'; then
341     echo " already installed."
342   else
343     if [ -f el/$elib.el ]; then
344       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
345     else
346       $echon " downloading$echoc"
347       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
348     fi
349     $echon " compiling$echoc"
350     (cd $HOME$sub/lib/emacs;
351       $emacs >/dev/null 2>&1 --no-site-file --batch \
352         --eval '(byte-compile-file "'"$elib.el"'")')
353     echo " done."
354   fi
355 done
356 echo "  all done."
357
358 $echon "Setting up Emacs configuration:$echoc"
359 $echon " linking$echoc"
360 for f in dot-emacs.el Makefile; do
361   set -- $(echo $link | tr : ' ')
362   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
363   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
364 done
365 $echon " compiling$echoc"
366 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
367 echo " done."
368
369 ###----- That's all, folks --------------------------------------------------